package net.core.editor.roles.diagram.edit.commands;

import net.core.editor.roles.BaseInheritanceEdge;
import net.core.editor.roles.BaseType;
import net.core.editor.roles.RoleModel;
import net.core.editor.roles.diagram.edit.policies.RoleBaseItemSemanticEditPolicy;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

/**
 * @generated
 */
public class BaseInheritanceEdgeReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public BaseInheritanceEdgeReorientCommand(
			ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof BaseInheritanceEdge) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof BaseType && newEnd instanceof BaseType)) {
			return false;
		}
		BaseType target = getLink().getTarget();
		if (!(getLink().eContainer() instanceof RoleModel)) {
			return false;
		}
		RoleModel container = (RoleModel) getLink().eContainer();
		return RoleBaseItemSemanticEditPolicy.LinkConstraints
				.canExistBaseInheritanceEdge_4007(container, getNewSource(),
						target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof BaseType && newEnd instanceof BaseType)) {
			return false;
		}
		BaseType source = getLink().getSource();
		if (!(getLink().eContainer() instanceof RoleModel)) {
			return false;
		}
		RoleModel container = (RoleModel) getLink().eContainer();
		return RoleBaseItemSemanticEditPolicy.LinkConstraints
				.canExistBaseInheritanceEdge_4007(container, source,
						getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setSource(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setTarget(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected BaseInheritanceEdge getLink() {
		return (BaseInheritanceEdge) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected BaseType getOldSource() {
		return (BaseType) oldEnd;
	}

	/**
	 * @generated
	 */
	protected BaseType getNewSource() {
		return (BaseType) newEnd;
	}

	/**
	 * @generated
	 */
	protected BaseType getOldTarget() {
		return (BaseType) oldEnd;
	}

	/**
	 * @generated
	 */
	protected BaseType getNewTarget() {
		return (BaseType) newEnd;
	}
}
