package net.core.editor.roles.diagram.edit.parts;

import net.core.editor.roles.diagram.edit.policies.AssociationEdgeItemSemanticEditPolicy;

import org.eclipse.draw2d.Connection;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ConnectionNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITreeBranchEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

/**
 * @generated
 */
public class AssociationEdgeEditPart extends ConnectionNodeEditPart implements
		ITreeBranchEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 4008;

	/**
	 * @generated
	 */
	public AssociationEdgeEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE,
				new AssociationEdgeItemSemanticEditPolicy());
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof AssociationEdgeSourceNameEditPart) {
			((AssociationEdgeSourceNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureAssociationSourceNameLabel());
			return true;
		}
		if (childEditPart instanceof AssociationEdgeSourceLowerBoundSourceUEditPart) {
			((AssociationEdgeSourceLowerBoundSourceUEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureAssociationSourceMultLabel());
			return true;
		}
		if (childEditPart instanceof AssociationEdgeTargetNameEditPart) {
			((AssociationEdgeTargetNameEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureAssociationTargetNameLabel());
			return true;
		}
		if (childEditPart instanceof AssociationEdgeTargetLowerBoundTargetUEditPart) {
			((AssociationEdgeTargetLowerBoundTargetUEditPart) childEditPart)
					.setLabel(getPrimaryShape()
							.getFigureAssociationTargetMultLabel());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof AssociationEdgeSourceNameEditPart) {
			return true;
		}
		if (childEditPart instanceof AssociationEdgeSourceLowerBoundSourceUEditPart) {
			return true;
		}
		if (childEditPart instanceof AssociationEdgeTargetNameEditPart) {
			return true;
		}
		if (childEditPart instanceof AssociationEdgeTargetLowerBoundTargetUEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */

	protected Connection createConnectionFigure() {
		return new AssociationEdgeConnection();
	}

	/**
	 * @generated
	 */
	public AssociationEdgeConnection getPrimaryShape() {
		return (AssociationEdgeConnection) getFigure();
	}

	/**
	 * @generated
	 */
	public class AssociationEdgeConnection extends PolylineConnectionEx {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureAssociationSourceNameLabel;
		/**
		 * @generated
		 */
		private WrappingLabel fFigureAssociationSourceMultLabel;
		/**
		 * @generated
		 */
		private WrappingLabel fFigureAssociationTargetNameLabel;
		/**
		 * @generated
		 */
		private WrappingLabel fFigureAssociationTargetMultLabel;

		/**
		 * @generated
		 */
		public AssociationEdgeConnection() {
			this.setLineWidth(1);
			this.setForegroundColor(THIS_FORE);

			createContents();
		}

		/**
		 * @generated
		 */
		private void createContents() {

			fFigureAssociationSourceNameLabel = new WrappingLabel();
			fFigureAssociationSourceNameLabel.setText("");

			this.add(fFigureAssociationSourceNameLabel);

			fFigureAssociationSourceMultLabel = new WrappingLabel();
			fFigureAssociationSourceMultLabel.setText("");

			this.add(fFigureAssociationSourceMultLabel);

			fFigureAssociationTargetNameLabel = new WrappingLabel();
			fFigureAssociationTargetNameLabel.setText("");

			this.add(fFigureAssociationTargetNameLabel);

			fFigureAssociationTargetMultLabel = new WrappingLabel();
			fFigureAssociationTargetMultLabel.setText("");

			this.add(fFigureAssociationTargetMultLabel);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureAssociationSourceNameLabel() {
			return fFigureAssociationSourceNameLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureAssociationSourceMultLabel() {
			return fFigureAssociationSourceMultLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureAssociationTargetNameLabel() {
			return fFigureAssociationTargetNameLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureAssociationTargetMultLabel() {
			return fFigureAssociationTargetMultLabel;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 0, 0, 0);

}
