package net.core.editor.roles.diagram.edit.parts;

import net.core.editor.roles.diagram.part.RoleVisualIDRegistry;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

/**
 * @generated
 */
public class RoleEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (RoleVisualIDRegistry.getVisualID(view)) {

			case RoleModelEditPart.VISUAL_ID:
				return new RoleModelEditPart(view);

			case BaseTypeEditPart.VISUAL_ID:
				return new BaseTypeEditPart(view);

			case BaseTypeNameEditPart.VISUAL_ID:
				return new BaseTypeNameEditPart(view);

			case CollaborationEditPart.VISUAL_ID:
				return new CollaborationEditPart(view);

			case CollaborationNameEditPart.VISUAL_ID:
				return new CollaborationNameEditPart(view);

			case AttributeEditPart.VISUAL_ID:
				return new AttributeEditPart(view);

			case AttributeNameTypeEditPart.VISUAL_ID:
				return new AttributeNameTypeEditPart(view);

			case MethodEditPart.VISUAL_ID:
				return new MethodEditPart(view);

			case MethodNameArgumentsReturnTypeEditPart.VISUAL_ID:
				return new MethodNameArgumentsReturnTypeEditPart(view);

			case RoleTypeEditPart.VISUAL_ID:
				return new RoleTypeEditPart(view);

			case RoleTypeNameEditPart.VISUAL_ID:
				return new RoleTypeNameEditPart(view);

			case Attribute2EditPart.VISUAL_ID:
				return new Attribute2EditPart(view);

			case AttributeNameType2EditPart.VISUAL_ID:
				return new AttributeNameType2EditPart(view);

			case Method2EditPart.VISUAL_ID:
				return new Method2EditPart(view);

			case MethodNameArgumentsReturnType2EditPart.VISUAL_ID:
				return new MethodNameArgumentsReturnType2EditPart(view);

			case BaseTypeBaseAttributeCompartmentEditPart.VISUAL_ID:
				return new BaseTypeBaseAttributeCompartmentEditPart(view);

			case BaseTypeBaseMethodCompartmentEditPart.VISUAL_ID:
				return new BaseTypeBaseMethodCompartmentEditPart(view);

			case CollaborationRoleTypeCompartmentEditPart.VISUAL_ID:
				return new CollaborationRoleTypeCompartmentEditPart(view);

			case RoleTypeRoleAttributeCompartmentEditPart.VISUAL_ID:
				return new RoleTypeRoleAttributeCompartmentEditPart(view);

			case RoleTypeRoleMethodCompartmentEditPart.VISUAL_ID:
				return new RoleTypeRoleMethodCompartmentEditPart(view);

			case RolePlayEdgeEditPart.VISUAL_ID:
				return new RolePlayEdgeEditPart(view);

			case WrappingLabelEditPart.VISUAL_ID:
				return new WrappingLabelEditPart(view);

			case RoleInheritanceEdgeEditPart.VISUAL_ID:
				return new RoleInheritanceEdgeEditPart(view);

			case BaseInheritanceEdgeEditPart.VISUAL_ID:
				return new BaseInheritanceEdgeEditPart(view);

			case AssociationEdgeEditPart.VISUAL_ID:
				return new AssociationEdgeEditPart(view);

			case AssociationEdgeSourceNameEditPart.VISUAL_ID:
				return new AssociationEdgeSourceNameEditPart(view);

			case AssociationEdgeSourceLowerBoundSourceUEditPart.VISUAL_ID:
				return new AssociationEdgeSourceLowerBoundSourceUEditPart(view);

			case AssociationEdgeTargetNameEditPart.VISUAL_ID:
				return new AssociationEdgeTargetNameEditPart(view);

			case AssociationEdgeTargetLowerBoundTargetUEditPart.VISUAL_ID:
				return new AssociationEdgeTargetLowerBoundTargetUEditPart(view);

			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrappingLabel)
			return new TextCellEditorLocator((WrappingLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrappingLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrappingLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (getWrapLabel().isTextWrapOn()
					&& getWrapLabel().getText().length() > 0) {
				rect.setSize(new Dimension(text.computeSize(rect.width,
						SWT.DEFAULT)));
			} else {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			int avr = FigureUtilities.getFontMetrics(text.getFont())
					.getAverageCharWidth();
			rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
					SWT.DEFAULT)).expand(avr * 2, 0));
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
