package net.core.editor.roles.diagram.edit.policies;

import java.util.Iterator;

import net.core.editor.roles.diagram.edit.commands.AssociationEdgeCreateCommand;
import net.core.editor.roles.diagram.edit.commands.AssociationEdgeReorientCommand;
import net.core.editor.roles.diagram.edit.commands.RoleInheritanceEdgeCreateCommand;
import net.core.editor.roles.diagram.edit.commands.RoleInheritanceEdgeReorientCommand;
import net.core.editor.roles.diagram.edit.commands.RolePlayEdgeCreateCommand;
import net.core.editor.roles.diagram.edit.commands.RolePlayEdgeReorientCommand;
import net.core.editor.roles.diagram.edit.parts.AssociationEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.Attribute2EditPart;
import net.core.editor.roles.diagram.edit.parts.Method2EditPart;
import net.core.editor.roles.diagram.edit.parts.RoleInheritanceEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RolePlayEdgeEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeRoleAttributeCompartmentEditPart;
import net.core.editor.roles.diagram.edit.parts.RoleTypeRoleMethodCompartmentEditPart;
import net.core.editor.roles.diagram.part.RoleVisualIDRegistry;
import net.core.editor.roles.diagram.providers.RoleElementTypes;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.common.core.command.ICompositeCommand;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

/**
 * @generated
 */
public class RoleTypeItemSemanticEditPolicy extends
		RoleBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public RoleTypeItemSemanticEditPolicy() {
		super(RoleElementTypes.RoleType_3009);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(
				getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		for (Iterator it = view.getTargetEdges().iterator(); it.hasNext();) {
			Edge incomingLink = (Edge) it.next();
			if (RoleVisualIDRegistry.getVisualID(incomingLink) == RoleInheritanceEdgeEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(
						incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (RoleVisualIDRegistry.getVisualID(incomingLink) == AssociationEdgeEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(
						incomingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
		}
		for (Iterator it = view.getSourceEdges().iterator(); it.hasNext();) {
			Edge outgoingLink = (Edge) it.next();
			if (RoleVisualIDRegistry.getVisualID(outgoingLink) == RolePlayEdgeEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(
						outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (RoleVisualIDRegistry.getVisualID(outgoingLink) == RoleInheritanceEdgeEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(
						outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
			if (RoleVisualIDRegistry.getVisualID(outgoingLink) == AssociationEdgeEditPart.VISUAL_ID) {
				DestroyElementRequest r = new DestroyElementRequest(
						outgoingLink.getElement(), false);
				cmd.add(new DestroyElementCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), outgoingLink));
				continue;
			}
		}
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null) {
			// there are indirectly referenced children, need extra commands: false
			addDestroyChildNodesCommand(cmd);
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		} else {
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	private void addDestroyChildNodesCommand(ICompositeCommand cmd) {
		View view = (View) getHost().getModel();
		for (Iterator nit = view.getChildren().iterator(); nit.hasNext();) {
			Node node = (Node) nit.next();
			switch (RoleVisualIDRegistry.getVisualID(node)) {
			case RoleTypeRoleAttributeCompartmentEditPart.VISUAL_ID:
				for (Iterator cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (RoleVisualIDRegistry.getVisualID(cnode)) {
					case Attribute2EditPart.VISUAL_ID:
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			case RoleTypeRoleMethodCompartmentEditPart.VISUAL_ID:
				for (Iterator cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (RoleVisualIDRegistry.getVisualID(cnode)) {
					case Method2EditPart.VISUAL_ID:
						cmd.add(new DestroyElementCommand(
								new DestroyElementRequest(getEditingDomain(),
										cnode.getElement(), false))); // directlyOwned: true
						// don't need explicit deletion of cnode as parent's view deletion would clean child views as well 
						// cmd.add(new org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand(getEditingDomain(), cnode));
						break;
					}
				}
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (RoleElementTypes.RolePlayEdge_4005 == req.getElementType()) {
			return getGEFWrapper(new RolePlayEdgeCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (RoleElementTypes.RoleInheritanceEdge_4006 == req.getElementType()) {
			return getGEFWrapper(new RoleInheritanceEdgeCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (RoleElementTypes.AssociationEdge_4008 == req.getElementType()) {
			return getGEFWrapper(new AssociationEdgeCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (RoleElementTypes.RolePlayEdge_4005 == req.getElementType()) {
			return null;
		}
		if (RoleElementTypes.RoleInheritanceEdge_4006 == req.getElementType()) {
			return getGEFWrapper(new RoleInheritanceEdgeCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (RoleElementTypes.AssociationEdge_4008 == req.getElementType()) {
			return getGEFWrapper(new AssociationEdgeCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(
			ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case RolePlayEdgeEditPart.VISUAL_ID:
			return getGEFWrapper(new RolePlayEdgeReorientCommand(req));
		case RoleInheritanceEdgeEditPart.VISUAL_ID:
			return getGEFWrapper(new RoleInheritanceEdgeReorientCommand(req));
		case AssociationEdgeEditPart.VISUAL_ID:
			return getGEFWrapper(new AssociationEdgeReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

}
