package net.core.editor.roles.diagram.part;

import java.util.ArrayList;
import java.util.List;

import net.core.editor.roles.diagram.providers.RoleElementTypes;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.PaletteSeparator;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

/**
 * @generated
 */
public class RolePaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createDefault1Group());
		paletteRoot.add(createTypes2Group());
		paletteRoot.add(createEdges3Group());
		paletteRoot.add(createFields4Group());
	}

	/**
	 * Creates "Default" palette tool group
	 * @generated
	 */
	private PaletteContainer createDefault1Group() {
		PaletteGroup paletteContainer = new PaletteGroup(
				Messages.Default1Group_title);
		paletteContainer.setId("createDefault1Group"); //$NON-NLS-1$
		paletteContainer.setDescription(Messages.Default1Group_desc);
		paletteContainer.add(new PaletteSeparator());
		paletteContainer.add(new PaletteSeparator());
		paletteContainer.add(new PaletteSeparator());
		return paletteContainer;
	}

	/**
	 * Creates "Types" palette tool group
	 * @generated
	 */
	private PaletteContainer createTypes2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Types2Group_title);
		paletteContainer.setId("createTypes2Group"); //$NON-NLS-1$
		paletteContainer.add(createRoleType1CreationTool());
		paletteContainer.add(createBaseType2CreationTool());
		paletteContainer.add(createCollaboration3CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Edges" palette tool group
	 * @generated
	 */
	private PaletteContainer createEdges3Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Edges3Group_title);
		paletteContainer.setId("createEdges3Group"); //$NON-NLS-1$
		paletteContainer.add(createRolePlayEdge1CreationTool());
		paletteContainer.add(createAssociationEdge2CreationTool());
		paletteContainer.add(createBaseInheritanceEdge3CreationTool());
		paletteContainer.add(createRoleInheritanceEdge4CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "Fields" palette tool group
	 * @generated
	 */
	private PaletteContainer createFields4Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(
				Messages.Fields4Group_title);
		paletteContainer.setId("createFields4Group"); //$NON-NLS-1$
		paletteContainer.add(createAttribute1CreationTool());
		paletteContainer.add(createMethod2CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRoleType1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(RoleElementTypes.RoleType_3009);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.RoleType1CreationTool_title,
				Messages.RoleType1CreationTool_desc, types);
		entry.setId("createRoleType1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.RoleType_3009));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createBaseType2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(RoleElementTypes.BaseType_2007);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.BaseType2CreationTool_title,
				Messages.BaseType2CreationTool_desc, types);
		entry.setId("createBaseType2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.BaseType_2007));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCollaboration3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(RoleElementTypes.Collaboration_2008);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Collaboration3CreationTool_title,
				Messages.Collaboration3CreationTool_desc, types);
		entry.setId("createCollaboration3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.Collaboration_2008));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRolePlayEdge1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(RoleElementTypes.RolePlayEdge_4005);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.RolePlayEdge1CreationTool_title,
				Messages.RolePlayEdge1CreationTool_desc, types);
		entry.setId("createRolePlayEdge1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.RolePlayEdge_4005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAssociationEdge2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(RoleElementTypes.AssociationEdge_4008);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.AssociationEdge2CreationTool_title,
				Messages.AssociationEdge2CreationTool_desc, types);
		entry.setId("createAssociationEdge2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.AssociationEdge_4008));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createBaseInheritanceEdge3CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(RoleElementTypes.BaseInheritanceEdge_4007);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.BaseInheritanceEdge3CreationTool_title,
				Messages.BaseInheritanceEdge3CreationTool_desc, types);
		entry.setId("createBaseInheritanceEdge3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.BaseInheritanceEdge_4007));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createRoleInheritanceEdge4CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(1);
		types.add(RoleElementTypes.RoleInheritanceEdge_4006);
		LinkToolEntry entry = new LinkToolEntry(
				Messages.RoleInheritanceEdge4CreationTool_title,
				Messages.RoleInheritanceEdge4CreationTool_desc, types);
		entry.setId("createRoleInheritanceEdge4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.RoleInheritanceEdge_4006));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAttribute1CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(RoleElementTypes.Attribute_3007);
		types.add(RoleElementTypes.Attribute_3010);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Attribute1CreationTool_title,
				Messages.Attribute1CreationTool_desc, types);
		entry.setId("createAttribute1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.Attribute_3007));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMethod2CreationTool() {
		List/*<IElementType>*/types = new ArrayList/*<IElementType>*/(2);
		types.add(RoleElementTypes.Method_3008);
		types.add(RoleElementTypes.Method_3011);
		NodeToolEntry entry = new NodeToolEntry(
				Messages.Method2CreationTool_title,
				Messages.Method2CreationTool_desc, types);
		entry.setId("createMethod2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(RoleElementTypes
				.getImageDescriptor(RoleElementTypes.Method_3008));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
