/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package net.core.editor.roles;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see net.core.editor.roles.RoleModelFactory
 * @model kind="package"
 * @generated
 */
public interface RoleModelPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "roles";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://net.core.editor/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "roles";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RoleModelPackage eINSTANCE = net.core.editor.roles.impl.RoleModelPackageImpl.init();

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.RoleModelImpl <em>Role Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.RoleModelImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRoleModel()
	 * @generated
	 */
	int ROLE_MODEL = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_MODEL__NAME = 0;

	/**
	 * The feature id for the '<em><b>Base Types</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_MODEL__BASE_TYPES = 1;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_MODEL__EDGES = 2;

	/**
	 * The feature id for the '<em><b>Collaborations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_MODEL__COLLABORATIONS = 3;

	/**
	 * The number of structural features of the '<em>Role Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_MODEL_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.TypeImpl <em>Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.TypeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getType()
	 * @generated
	 */
	int TYPE = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__ATTRIBUTES = 1;

	/**
	 * The feature id for the '<em><b>Methods</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE__METHODS = 2;

	/**
	 * The number of structural features of the '<em>Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.BaseTypeImpl <em>Base Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.BaseTypeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getBaseType()
	 * @generated
	 */
	int BASE_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_TYPE__NAME = TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_TYPE__ATTRIBUTES = TYPE__ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Methods</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_TYPE__METHODS = TYPE__METHODS;

	/**
	 * The number of structural features of the '<em>Base Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_TYPE_FEATURE_COUNT = TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.RoleTypeImpl <em>Role Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.RoleTypeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRoleType()
	 * @generated
	 */
	int ROLE_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_TYPE__NAME = TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_TYPE__ATTRIBUTES = TYPE__ATTRIBUTES;

	/**
	 * The feature id for the '<em><b>Methods</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_TYPE__METHODS = TYPE__METHODS;

	/**
	 * The number of structural features of the '<em>Role Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_TYPE_FEATURE_COUNT = TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.EdgeImpl <em>Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.EdgeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getEdge()
	 * @generated
	 */
	int EDGE = 4;

	/**
	 * The number of structural features of the '<em>Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDGE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.RolePlayEdgeImpl <em>Role Play Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.RolePlayEdgeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRolePlayEdge()
	 * @generated
	 */
	int ROLE_PLAY_EDGE = 5;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_PLAY_EDGE__SOURCE = EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_PLAY_EDGE__TARGET = EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Role Play Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_PLAY_EDGE_FEATURE_COUNT = EDGE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.BaseInheritanceEdgeImpl <em>Base Inheritance Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.BaseInheritanceEdgeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getBaseInheritanceEdge()
	 * @generated
	 */
	int BASE_INHERITANCE_EDGE = 6;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_INHERITANCE_EDGE__SOURCE = EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_INHERITANCE_EDGE__TARGET = EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Base Inheritance Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BASE_INHERITANCE_EDGE_FEATURE_COUNT = EDGE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.RoleInheritanceEdgeImpl <em>Role Inheritance Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.RoleInheritanceEdgeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRoleInheritanceEdge()
	 * @generated
	 */
	int ROLE_INHERITANCE_EDGE = 7;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_INHERITANCE_EDGE__SOURCE = EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_INHERITANCE_EDGE__TARGET = EDGE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Role Inheritance Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ROLE_INHERITANCE_EDGE_FEATURE_COUNT = EDGE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.AttributeImpl <em>Attribute</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.AttributeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getAttribute()
	 * @generated
	 */
	int ATTRIBUTE = 8;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__TYPE = 1;

	/**
	 * The number of structural features of the '<em>Attribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.MethodImpl <em>Method</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.MethodImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getMethod()
	 * @generated
	 */
	int METHOD = 9;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METHOD__NAME = 0;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METHOD__RETURN_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Arguments</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METHOD__ARGUMENTS = 2;

	/**
	 * The number of structural features of the '<em>Method</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int METHOD_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.CollaborationImpl <em>Collaboration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.CollaborationImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getCollaboration()
	 * @generated
	 */
	int COLLABORATION = 10;

	/**
	 * The feature id for the '<em><b>Role Types</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLABORATION__ROLE_TYPES = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLABORATION__NAME = 1;

	/**
	 * The number of structural features of the '<em>Collaboration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLABORATION_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link net.core.editor.roles.impl.AssociationEdgeImpl <em>Association Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.core.editor.roles.impl.AssociationEdgeImpl
	 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getAssociationEdge()
	 * @generated
	 */
	int ASSOCIATION_EDGE = 11;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE = EDGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET = EDGE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Source Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE_NAME = EDGE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Target Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET_NAME = EDGE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Source Lower Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE_LOWER_BOUND = EDGE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Source Upper Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__SOURCE_UPPER_BOUND = EDGE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Target Lower Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET_LOWER_BOUND = EDGE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Target Upper Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE__TARGET_UPPER_BOUND = EDGE_FEATURE_COUNT + 7;

	/**
	 * The number of structural features of the '<em>Association Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ASSOCIATION_EDGE_FEATURE_COUNT = EDGE_FEATURE_COUNT + 8;


	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.RoleModel <em>Role Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Role Model</em>'.
	 * @see net.core.editor.roles.RoleModel
	 * @generated
	 */
	EClass getRoleModel();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.RoleModel#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.core.editor.roles.RoleModel#getName()
	 * @see #getRoleModel()
	 * @generated
	 */
	EAttribute getRoleModel_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link net.core.editor.roles.RoleModel#getBaseTypes <em>Base Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Base Types</em>'.
	 * @see net.core.editor.roles.RoleModel#getBaseTypes()
	 * @see #getRoleModel()
	 * @generated
	 */
	EReference getRoleModel_BaseTypes();

	/**
	 * Returns the meta object for the containment reference list '{@link net.core.editor.roles.RoleModel#getEdges <em>Edges</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Edges</em>'.
	 * @see net.core.editor.roles.RoleModel#getEdges()
	 * @see #getRoleModel()
	 * @generated
	 */
	EReference getRoleModel_Edges();

	/**
	 * Returns the meta object for the containment reference list '{@link net.core.editor.roles.RoleModel#getCollaborations <em>Collaborations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Collaborations</em>'.
	 * @see net.core.editor.roles.RoleModel#getCollaborations()
	 * @see #getRoleModel()
	 * @generated
	 */
	EReference getRoleModel_Collaborations();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.Type <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type</em>'.
	 * @see net.core.editor.roles.Type
	 * @generated
	 */
	EClass getType();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.Type#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.core.editor.roles.Type#getName()
	 * @see #getType()
	 * @generated
	 */
	EAttribute getType_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link net.core.editor.roles.Type#getAttributes <em>Attributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Attributes</em>'.
	 * @see net.core.editor.roles.Type#getAttributes()
	 * @see #getType()
	 * @generated
	 */
	EReference getType_Attributes();

	/**
	 * Returns the meta object for the containment reference list '{@link net.core.editor.roles.Type#getMethods <em>Methods</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Methods</em>'.
	 * @see net.core.editor.roles.Type#getMethods()
	 * @see #getType()
	 * @generated
	 */
	EReference getType_Methods();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.BaseType <em>Base Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Base Type</em>'.
	 * @see net.core.editor.roles.BaseType
	 * @generated
	 */
	EClass getBaseType();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.RoleType <em>Role Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Role Type</em>'.
	 * @see net.core.editor.roles.RoleType
	 * @generated
	 */
	EClass getRoleType();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.Edge <em>Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Edge</em>'.
	 * @see net.core.editor.roles.Edge
	 * @generated
	 */
	EClass getEdge();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.RolePlayEdge <em>Role Play Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Role Play Edge</em>'.
	 * @see net.core.editor.roles.RolePlayEdge
	 * @generated
	 */
	EClass getRolePlayEdge();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.RolePlayEdge#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see net.core.editor.roles.RolePlayEdge#getSource()
	 * @see #getRolePlayEdge()
	 * @generated
	 */
	EReference getRolePlayEdge_Source();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.RolePlayEdge#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see net.core.editor.roles.RolePlayEdge#getTarget()
	 * @see #getRolePlayEdge()
	 * @generated
	 */
	EReference getRolePlayEdge_Target();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.BaseInheritanceEdge <em>Base Inheritance Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Base Inheritance Edge</em>'.
	 * @see net.core.editor.roles.BaseInheritanceEdge
	 * @generated
	 */
	EClass getBaseInheritanceEdge();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.BaseInheritanceEdge#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see net.core.editor.roles.BaseInheritanceEdge#getSource()
	 * @see #getBaseInheritanceEdge()
	 * @generated
	 */
	EReference getBaseInheritanceEdge_Source();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.BaseInheritanceEdge#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see net.core.editor.roles.BaseInheritanceEdge#getTarget()
	 * @see #getBaseInheritanceEdge()
	 * @generated
	 */
	EReference getBaseInheritanceEdge_Target();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.RoleInheritanceEdge <em>Role Inheritance Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Role Inheritance Edge</em>'.
	 * @see net.core.editor.roles.RoleInheritanceEdge
	 * @generated
	 */
	EClass getRoleInheritanceEdge();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.RoleInheritanceEdge#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see net.core.editor.roles.RoleInheritanceEdge#getSource()
	 * @see #getRoleInheritanceEdge()
	 * @generated
	 */
	EReference getRoleInheritanceEdge_Source();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.RoleInheritanceEdge#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see net.core.editor.roles.RoleInheritanceEdge#getTarget()
	 * @see #getRoleInheritanceEdge()
	 * @generated
	 */
	EReference getRoleInheritanceEdge_Target();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.Attribute <em>Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Attribute</em>'.
	 * @see net.core.editor.roles.Attribute
	 * @generated
	 */
	EClass getAttribute();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.Attribute#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.core.editor.roles.Attribute#getName()
	 * @see #getAttribute()
	 * @generated
	 */
	EAttribute getAttribute_Name();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.Attribute#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see net.core.editor.roles.Attribute#getType()
	 * @see #getAttribute()
	 * @generated
	 */
	EAttribute getAttribute_Type();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.Method <em>Method</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Method</em>'.
	 * @see net.core.editor.roles.Method
	 * @generated
	 */
	EClass getMethod();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.Method#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.core.editor.roles.Method#getName()
	 * @see #getMethod()
	 * @generated
	 */
	EAttribute getMethod_Name();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.Method#getReturnType <em>Return Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Return Type</em>'.
	 * @see net.core.editor.roles.Method#getReturnType()
	 * @see #getMethod()
	 * @generated
	 */
	EAttribute getMethod_ReturnType();

	/**
	 * Returns the meta object for the attribute list '{@link net.core.editor.roles.Method#getArguments <em>Arguments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Arguments</em>'.
	 * @see net.core.editor.roles.Method#getArguments()
	 * @see #getMethod()
	 * @generated
	 */
	EAttribute getMethod_Arguments();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.Collaboration <em>Collaboration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Collaboration</em>'.
	 * @see net.core.editor.roles.Collaboration
	 * @generated
	 */
	EClass getCollaboration();

	/**
	 * Returns the meta object for the containment reference list '{@link net.core.editor.roles.Collaboration#getRoleTypes <em>Role Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Role Types</em>'.
	 * @see net.core.editor.roles.Collaboration#getRoleTypes()
	 * @see #getCollaboration()
	 * @generated
	 */
	EReference getCollaboration_RoleTypes();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.Collaboration#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.core.editor.roles.Collaboration#getName()
	 * @see #getCollaboration()
	 * @generated
	 */
	EAttribute getCollaboration_Name();

	/**
	 * Returns the meta object for class '{@link net.core.editor.roles.AssociationEdge <em>Association Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Association Edge</em>'.
	 * @see net.core.editor.roles.AssociationEdge
	 * @generated
	 */
	EClass getAssociationEdge();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.AssociationEdge#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getSource()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EReference getAssociationEdge_Source();

	/**
	 * Returns the meta object for the reference '{@link net.core.editor.roles.AssociationEdge#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getTarget()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EReference getAssociationEdge_Target();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.AssociationEdge#getSourceName <em>Source Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Name</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getSourceName()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EAttribute getAssociationEdge_SourceName();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.AssociationEdge#getTargetName <em>Target Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Target Name</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getTargetName()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EAttribute getAssociationEdge_TargetName();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.AssociationEdge#getSourceLowerBound <em>Source Lower Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Lower Bound</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getSourceLowerBound()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EAttribute getAssociationEdge_SourceLowerBound();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.AssociationEdge#getSourceUpperBound <em>Source Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Source Upper Bound</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getSourceUpperBound()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EAttribute getAssociationEdge_SourceUpperBound();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.AssociationEdge#getTargetLowerBound <em>Target Lower Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Target Lower Bound</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getTargetLowerBound()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EAttribute getAssociationEdge_TargetLowerBound();

	/**
	 * Returns the meta object for the attribute '{@link net.core.editor.roles.AssociationEdge#getTargetUpperBound <em>Target Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Target Upper Bound</em>'.
	 * @see net.core.editor.roles.AssociationEdge#getTargetUpperBound()
	 * @see #getAssociationEdge()
	 * @generated
	 */
	EAttribute getAssociationEdge_TargetUpperBound();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	RoleModelFactory getRoleModelFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.RoleModelImpl <em>Role Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.RoleModelImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRoleModel()
		 * @generated
		 */
		EClass ROLE_MODEL = eINSTANCE.getRoleModel();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ROLE_MODEL__NAME = eINSTANCE.getRoleModel_Name();

		/**
		 * The meta object literal for the '<em><b>Base Types</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE_MODEL__BASE_TYPES = eINSTANCE.getRoleModel_BaseTypes();

		/**
		 * The meta object literal for the '<em><b>Edges</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE_MODEL__EDGES = eINSTANCE.getRoleModel_Edges();

		/**
		 * The meta object literal for the '<em><b>Collaborations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE_MODEL__COLLABORATIONS = eINSTANCE.getRoleModel_Collaborations();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.TypeImpl <em>Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.TypeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getType()
		 * @generated
		 */
		EClass TYPE = eINSTANCE.getType();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TYPE__NAME = eINSTANCE.getType_Name();

		/**
		 * The meta object literal for the '<em><b>Attributes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TYPE__ATTRIBUTES = eINSTANCE.getType_Attributes();

		/**
		 * The meta object literal for the '<em><b>Methods</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TYPE__METHODS = eINSTANCE.getType_Methods();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.BaseTypeImpl <em>Base Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.BaseTypeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getBaseType()
		 * @generated
		 */
		EClass BASE_TYPE = eINSTANCE.getBaseType();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.RoleTypeImpl <em>Role Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.RoleTypeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRoleType()
		 * @generated
		 */
		EClass ROLE_TYPE = eINSTANCE.getRoleType();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.EdgeImpl <em>Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.EdgeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getEdge()
		 * @generated
		 */
		EClass EDGE = eINSTANCE.getEdge();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.RolePlayEdgeImpl <em>Role Play Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.RolePlayEdgeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRolePlayEdge()
		 * @generated
		 */
		EClass ROLE_PLAY_EDGE = eINSTANCE.getRolePlayEdge();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE_PLAY_EDGE__SOURCE = eINSTANCE.getRolePlayEdge_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE_PLAY_EDGE__TARGET = eINSTANCE.getRolePlayEdge_Target();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.BaseInheritanceEdgeImpl <em>Base Inheritance Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.BaseInheritanceEdgeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getBaseInheritanceEdge()
		 * @generated
		 */
		EClass BASE_INHERITANCE_EDGE = eINSTANCE.getBaseInheritanceEdge();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BASE_INHERITANCE_EDGE__SOURCE = eINSTANCE.getBaseInheritanceEdge_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BASE_INHERITANCE_EDGE__TARGET = eINSTANCE.getBaseInheritanceEdge_Target();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.RoleInheritanceEdgeImpl <em>Role Inheritance Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.RoleInheritanceEdgeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getRoleInheritanceEdge()
		 * @generated
		 */
		EClass ROLE_INHERITANCE_EDGE = eINSTANCE.getRoleInheritanceEdge();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE_INHERITANCE_EDGE__SOURCE = eINSTANCE.getRoleInheritanceEdge_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ROLE_INHERITANCE_EDGE__TARGET = eINSTANCE.getRoleInheritanceEdge_Target();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.AttributeImpl <em>Attribute</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.AttributeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getAttribute()
		 * @generated
		 */
		EClass ATTRIBUTE = eINSTANCE.getAttribute();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ATTRIBUTE__NAME = eINSTANCE.getAttribute_Name();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ATTRIBUTE__TYPE = eINSTANCE.getAttribute_Type();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.MethodImpl <em>Method</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.MethodImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getMethod()
		 * @generated
		 */
		EClass METHOD = eINSTANCE.getMethod();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute METHOD__NAME = eINSTANCE.getMethod_Name();

		/**
		 * The meta object literal for the '<em><b>Return Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute METHOD__RETURN_TYPE = eINSTANCE.getMethod_ReturnType();

		/**
		 * The meta object literal for the '<em><b>Arguments</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute METHOD__ARGUMENTS = eINSTANCE.getMethod_Arguments();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.CollaborationImpl <em>Collaboration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.CollaborationImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getCollaboration()
		 * @generated
		 */
		EClass COLLABORATION = eINSTANCE.getCollaboration();

		/**
		 * The meta object literal for the '<em><b>Role Types</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COLLABORATION__ROLE_TYPES = eINSTANCE.getCollaboration_RoleTypes();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COLLABORATION__NAME = eINSTANCE.getCollaboration_Name();

		/**
		 * The meta object literal for the '{@link net.core.editor.roles.impl.AssociationEdgeImpl <em>Association Edge</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.core.editor.roles.impl.AssociationEdgeImpl
		 * @see net.core.editor.roles.impl.RoleModelPackageImpl#getAssociationEdge()
		 * @generated
		 */
		EClass ASSOCIATION_EDGE = eINSTANCE.getAssociationEdge();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSOCIATION_EDGE__SOURCE = eINSTANCE.getAssociationEdge_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ASSOCIATION_EDGE__TARGET = eINSTANCE.getAssociationEdge_Target();

		/**
		 * The meta object literal for the '<em><b>Source Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ASSOCIATION_EDGE__SOURCE_NAME = eINSTANCE.getAssociationEdge_SourceName();

		/**
		 * The meta object literal for the '<em><b>Target Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ASSOCIATION_EDGE__TARGET_NAME = eINSTANCE.getAssociationEdge_TargetName();

		/**
		 * The meta object literal for the '<em><b>Source Lower Bound</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ASSOCIATION_EDGE__SOURCE_LOWER_BOUND = eINSTANCE.getAssociationEdge_SourceLowerBound();

		/**
		 * The meta object literal for the '<em><b>Source Upper Bound</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ASSOCIATION_EDGE__SOURCE_UPPER_BOUND = eINSTANCE.getAssociationEdge_SourceUpperBound();

		/**
		 * The meta object literal for the '<em><b>Target Lower Bound</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ASSOCIATION_EDGE__TARGET_LOWER_BOUND = eINSTANCE.getAssociationEdge_TargetLowerBound();

		/**
		 * The meta object literal for the '<em><b>Target Upper Bound</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ASSOCIATION_EDGE__TARGET_UPPER_BOUND = eINSTANCE.getAssociationEdge_TargetUpperBound();

	}

} //RoleModelPackage
